#include<bits/stdc++.h>
using namespace std;
int main() {
    int a, b;
   cin >> a >> b;
    unordered_set<int> st;
   vector<int> arr(b),ar,v,vr;
    for (int i = 0; i < b; i++) {
       cin >> arr[i];
       st.insert(arr[i]);
       ar.push_back(arr[i]);
    }
    sort(ar.begin(),ar.end());
    int cnt=1;
    for(int i=0;i<ar.size();i++)
    {
        if(ar[i]==ar[i+1])
            cnt++;
        else
        {
            if(cnt>=a)
            {
                v.push_back(ar[i]);
            }
            cnt=1;
        }
    }
    cout<<v.size()<<endl;
   for(auto i:st)
   {
       for(int j=0;j<v.size();j++)
       {
            if(v[j]==i)
                vr.push_back(i);
       }
   }
   reverse(vr.begin(),vr.end());
   for(int i=0;i<vr.size();i++)
    cout<<vr[i]<<' ';
}
